%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                    PSG Type    PSG Object           Location in Problem Statement                     Class
%matrix_orthogonal_data    data        matrix_orthogonal    linear(matrix_orthogonal)                         double
%matrix_orthogonal_vars    vars        matrix_orthogonal    linear(matrix_orthogonal)                         cell
%point_initial_data        data        point_initial        Solver: stages=30, init_point  = point_initial    double
%point_initial_vars        vars        point_initial        Solver: stages=30, init_point  = point_initial    cell
%matrix_H_data             data        matrix_h             pr_pen(parameter_alpha1,matrix_h)                 double
%alpha1                    data        parameter_alpha1     pr_pen(parameter_alpha1,matrix_h)                 double
%bound                     data        parameter_bound1     Constraint: ==  parameter_bound1                  double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_orthogonal_data,matrix_orthogonal_vars,point_initial_data,point_initial_vars,matrix_H_data,alpha1,bound)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_orthogonal',matrix_orthogonal_data,matrix_orthogonal_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_initial',point_initial_data,point_initial_vars);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_h',matrix_H_data,[],[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  pr_pen(parameter_alpha1,matrix_h)',...
'Constraint: ==  parameter_bound1',...
'  linear(matrix_orthogonal)',...
'Solver: stages=30, init_point  = point_initial',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha1',num2str(alpha1));
problem_statement = strrep(problem_statement,'parameter_bound1',num2str(bound));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

